Name: gitolite
Version: 2.0
Release: alt1

Summary: Highly flexible server for git directory version tracker
License: GPLv2
Group: System/Servers

Url: http://github.com/sitaramc/gitolite
Source0: %name-%version.tar
# actually fedora's too but the naming would be confusing;
# it does fit nicely though
Source1: README.ALT
# (fedora) Far from being upstreamable
Patch: gitolite-2.0-rpm.patch
Packager: Michael Shigorin <mike@altlinux.org>

BuildArch: noarch

# Automatically added by buildreq on Wed Apr 20 2011 (-bi)
# optimized out: perl-Encode perl-Text-Balanced
BuildRequires: perl-Text-Markdown

Requires: git-core
Requires: openssh-clients
Requires(pre): shadow-utils

# "no rc file"
AutoReq: yes, noperl

%define gitolite_homedir %_localstatedir/%name

%description
Gitolite allows a server to host many git repositories and
provide access to many developers, without having to give them
real userids on the server.  The essential magic in doing this
is ssh's pubkey access and the authorized keys file, and the
inspiration was an older program called gitosis.

Gitolite can restrict who can read from (clone/fetch) or write
to (push) a repository. It can also restrict who can push to what
branch or tag, which is very important in a corporate environment.
Gitolite can be installed without requiring root permissions, and
with no additional software than git itself and perl. It also has
several other neat features described below and elsewhere in the
doc/ directory.

%prep
%setup
%patch -p1
cp %SOURCE1 .

%build
# Drop gl-easy-install per upstream.
rm -f src/gl-easy-install
# Format documentation
for F in doc/*.mkd; do
        perl -MText::Markdown >${F/.mkd/.html} <$F \
                -e 'print Text::Markdown::markdown (join "", <>)'
done

%install
install -d %buildroot%gitolite_homedir/.ssh
install -d %buildroot%_bindir
install -d %buildroot%perl_vendor_privlib
install -d %buildroot%_datadir/%name

install -p src/gl-* %buildroot%_bindir/
install -pm644 src/*.pm %buildroot%perl_vendor_privlib/
cp -a conf hooks %buildroot%_datadir/%name/

touch %buildroot%gitolite_homedir/.ssh/authorized_keys

%pre
# FIXME: _%name?
getent group %name >/dev/null || groupadd -r %name
getent passwd %name >/dev/null || \
useradd -r -g %name -d %gitolite_homedir -s /bin/sh \
        -c "git repository hosting" %name
exit 0

%files
%_bindir/*
%perl_vendor_privlib/*
%_datadir/%name
%attr(750,%name,%name) %dir %gitolite_homedir
%attr(750,%name,%name) %dir %gitolite_homedir/.ssh
%config(noreplace) %attr(640,%name,%name) %gitolite_homedir/.ssh/authorized_keys
%doc doc/COPYING doc/*.html *README*

%changelog
* Wed Apr 20 2011 Michael Shigorin <mike@altlinux.org> 2.0-alt1
- initial build for ALT Linux Sisyphus
  + based on 2.0-1 fedora package by Jon Ciesla <limb/jcomserv.net>
